<template>
    <form @submit.prevent="onSubmit" class="space-y-4">
        <div class="flex gap-32">
            <div class="flex-1 space-y-4">
                <div class="form-control">
                    <label class="flex flex-col" for="course_category_id">
                        <div>Môn học <span class="text-red-500">*</span></div>
                        <select
                            v-model="data.course_category_id"
                            id="course_category_id"
                            class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2.5"
                            :class="{
                                'border-red-400': dataErrors.course_category_id
                            }"
                        >
                            <option disabled value="">Chọn môn học</option>
                            <option
                                :key="category.id"
                                v-for="category in SELECT_OPTION_COURSE_CATEGORY"
                                :value="category.id"
                            >
                                {{ category.text }}
                            </option>
                        </select>
                    </label>
                    <div
                        v-if="dataErrors.course_category_id"
                        class="text-left text-sm text-red-500 mt-1"
                    >
                        {{ dataErrors.course_category_id }}
                    </div>
                </div>

                <div class="form-control">
                    <label class="flex flex-col" for="name">
                        <div>
                            Tên khóa học <span class="text-red-500">*</span>
                        </div>
                        <input
                            v-model="data.name"
                            id="name"
                            type="text"
                            class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                            :class="{ 'border-red-400': dataErrors.name }"
                        />
                    </label>
                    <div
                        v-if="dataErrors.name"
                        class="text-left text-sm text-red-500 mt-1"
                    >
                        {{ dataErrors.name }}
                    </div>
                </div>

                <div class="form-control">
                    <div>
                        Yêu cầu học lần lượt <span class="text-red-500">*</span>
                    </div>
                    <div class="mt-1 ml-8">
                        <div class="radio-custom">
                            <input
                                id="sequence"
                                type="radio"
                                v-model="data.is_sequence"
                                :value="TYPE_COURSE_SEQUENCE.id"
                            />
                            <label for="sequence" class="pl-7">
                                {{ TYPE_COURSE_SEQUENCE.text }}
                            </label>
                        </div>
                        <div class="radio-custom">
                            <input
                                id="not-sequence"
                                type="radio"
                                v-model="data.is_sequence"
                                :value="TYPE_COURSE_NOT_SEQUENCE.id"
                            />
                            <label for="not-sequence" class="pl-7">
                                {{ TYPE_COURSE_NOT_SEQUENCE.text }}
                            </label>
                        </div>
                    </div>
                    <div
                        v-if="dataErrors.is_sequence"
                        class="text-left text-sm text-red-500 mt-1"
                    >
                        {{ dataErrors.is_sequence }}
                    </div>
                </div>
            </div>
            <div class="flex-1">
                <div class="form-control">
                    <div>Hình ảnh</div>
                    <div class="flex items-center gap-5 mt-1">
                        <UploadButton v-model:urlImage="data.image" />
                        <div id="image" class="relative w-48">
                            <div
                                v-show="data.image"
                                @click="onDeleteImage"
                                class="absolute top-0 right-0 cursor-pointer"
                            >
                                <Tooltip text="Xóa ảnh">
                                    <XCircleIcon class="h-8 w-8" />
                                </Tooltip>
                            </div>
                            <img v-show="data.image" :src="data.image" alt="" />
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="form-control">
            <label class="flex flex-col" for="description">
                <div class="mb-1">Mô tả khóa học</div>
                <QuillEditor
                    id="description"
                    v-model:content="data.description"
                />
            </label>
            <div
                v-if="dataErrors.description"
                class="text-left text-sm text-red-500 mt-1"
            >
                {{ dataErrors.description }}
            </div>
        </div>

        <div class="form-control flex items-center gap-3">
            <BasicButton type="submit">
                {{ isUpdate ? "Cập nhật" : "Thêm" }}
            </BasicButton>
            <LinkButton
                nameRoute="teacher-course"
                classCustom="bg-color-danger hover:shadow-hover-danger"
            >
                Hủy
            </LinkButton>
        </div>
    </form>
</template>

<script>
import { reactive, ref } from "vue";
import { useRouter } from "vue-router";
import { createToast } from "mosha-vue-toastify";
import {
    SELECT_OPTION_COURSE_CATEGORY,
    TYPE_COURSE_NOT_SEQUENCE,
    TYPE_COURSE_SEQUENCE
} from "@/constants";

import useCreateCourse from "@/hooks/course/useCreateCourse";
import useUpdateCourse from "@/hooks/course/useUpdateCourse";

import { XCircleIcon } from "@heroicons/vue/outline";
import QuillEditor from "@/components/quill-editor/QuillEditorVue3.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import LinkButton from "@/components/button/LinkButton.vue";
import UploadButton from "@/components/button/UploadButton.vue";
import Tooltip from "@/components/tooltip/Tooltip.vue";

export default {
    components: {
        XCircleIcon,
        QuillEditor,
        BasicButton,
        LinkButton,
        UploadButton,
        Tooltip
    },
    props: {
        course: {
            type: Object
        }
    },
    setup(props) {
        const router = useRouter();
        const isUpdate = ref(props.course ? true : false);
        const { errorResponse, onCreateCourse } = useCreateCourse();
        const { errorResponseUpdate, onUpdateCourse } = useUpdateCourse();

        const data = reactive({
            name: props.course ? props.course.name : "",
            image: props.course?.image ? props.course.image : "",
            description: props.course?.description
                ? props.course.description
                : "",
            course_category_id: props.course
                ? props.course.course_category_id
                : "",
            is_sequence: props.course ? props.course.is_sequence : ""
        });

        const dataErrors = reactive({
            name: null,
            image: null,
            description: null,
            course_category_id: null,
            is_sequence: null
        });

        function onDeleteImage() {
            data.image = "";
        }

        async function onSubmit() {
            dataErrors.name = null;
            dataErrors.description = null;
            dataErrors.course_category_id = null;
            dataErrors.is_sequence = null;

            let input_valid = true;
            // check empty input
            if (
                !data.name ||
                !data.course_category_id ||
                data.is_sequence === ""
            ) {
                input_valid = false;
                if (!data.name) dataErrors.name = "Bạn chưa nhập tên khóa học";
                if (!data.course_category_id)
                    dataErrors.course_category_id = "Bạn chưa chọn môn học";
                if (data.is_sequence === "")
                    dataErrors.is_sequence = "Bạn chưa chọn loại khóa học";
            }

            // check input valid and submit form
            if (input_valid) {
                // show loading
                document.getElementById("full-page-loading").style.display =
                    "block";

                if (isUpdate.value) {
                    await onUpdateCourse(props.course.id, data);
                } else {
                    await onCreateCourse(data);
                }

                // hide loading
                document.getElementById("full-page-loading").style.display =
                    "none";

                // check error from server
                if (errorResponse.value || errorResponseUpdate.value) {
                    if (errorResponseUpdate.value) {
                        errorResponse.value = errorResponseUpdate.value;
                    }
                    if (
                        errorResponse.value.name &&
                        errorResponse.value.name.length
                    ) {
                        dataErrors.name = errorResponse.value.name[0];
                    }
                    if (
                        errorResponse.value.course_category_id &&
                        errorResponse.value.course_category_id.length
                    ) {
                        dataErrors.course_category_id =
                            errorResponse.value.course_category_id[0];
                    }
                    if (
                        errorResponse.value.is_sequence &&
                        errorResponse.value.is_sequence.length
                    ) {
                        dataErrors.is_sequence =
                            errorResponse.value.is_sequence[0];
                    }
                } else {
                    createToast(
                        isUpdate.value
                            ? "Cập nhật khóa học thành công"
                            : "Tạo khóa học thành công",
                        {
                            showIcon: true,
                            type: "success"
                        }
                    );
                    router.push({ name: "teacher-course", params: {} });
                }
            }
        }

        return {
            SELECT_OPTION_COURSE_CATEGORY,
            TYPE_COURSE_NOT_SEQUENCE,
            TYPE_COURSE_SEQUENCE,
            isUpdate,
            data,
            dataErrors,
            onDeleteImage,
            onSubmit
        };
    }
};
</script>

<style lang="scss" scoped>
#image > div {
    transform: translate(45%, -45%);
}
</style>
